#define info printf
#define error(v)do{printf("error-"#v"\n");local_stats.err_##v++;goto err;}while(0)
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <errno.h>
#include <netinet/in.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/uio.h>
#include <sys/shm.h>
#include <stdlib.h>
#define SET(n,sets)((struct event_set*)((char*)sets+sets_offset+n*set_size))
#define PACKET(n,set)((struct packet_hdr*)((char*)set+packets_offset+n*packet_size))
#define EVENT(n,set)((struct event_hdr*)((char*)set+events_offset+n*event_size))
#define VECTORS(n,ev)((struct iovec*)((char*)ev+vectors_offset+n*vector_size))
#define FRAGMENT(n,ev)((struct iovec*)((char*)ev+fragments_offset+n*vector_size))
#include "mep.h"
#define streq !strcmp
#define level_l1 0
#define level_hlt 1
#define checkconfigbug(keyw,n)do{if(r!=n){ \
fprintf(stderr,"config error: %s expects %d arguments.\n",keyw,n-1);abort();} \
} \
while(0);
#include "ebmon.h"
#define max_ip_tot_len 3000
#define LOCK(x)
#define UNLOCK(x)
#include <string.h>
#include <assert.h>

struct generic_item
{
  struct generic_item *prev;
  struct generic_item *next;
  struct generic_q *q;
};

struct generic_q
{
  struct generic_item *head;
  struct generic_item *tail;
};
struct packet_hdr
{
  char received;
  int len;
  char *data;
  struct mephdr *mep;
  struct efhdr *ef;
  struct efhdr *frag1;
};

struct event_hdr
{
  int len;
  int number;
  char forwarded;
};

struct event_set
{
  void *prev;
  void *next;
  struct generic_q *q;
  int number;
  int count;
  int ev_count;
};
struct ulb
{
  char *data;
  int len;
};

struct packet_desc
{
  void *prev;
  void *next;
  struct generic_q *q;
#ifdef __KERNEL__
  struct sk_buff *buf;
#else
  struct ulb *buf;
#endif
  struct iphdr *ip;
  struct mephdr *mep;
  struct efhdr *frag1;
  int location;
  int dependencies;
  struct event_desc **events;
};
struct source
{
  int id;
};
struct iphdr *ip;
struct mephdr *mep;
struct efhdr *ef;
__u32 mep_packet_len;
struct event_set *descriptors_e;
struct generic_q null_events, incomplete_events, built_events;
int socket_l1;
struct sockaddr_in sender_information;
int sender_sockaddr_len;
int shm_id;
char *shared_memory = NULL;
struct shmid_ds shm_ds;
int sets_offset, packets_offset, events_offset, vectors_offset,
  fragments_offset;
int set_size, packet_size, event_size, vector_size, fragment_size;
struct generic_q empty_packets, full_packets, full_packets2;
struct packet_desc *descriptors_p;
struct ulb *buffers_p;
struct event_set *event_sets;
int nb_incomplete = 0;
int pass;
struct ebmon *exports;
struct ebmon local_stats;
char ip_packet[max_ip_tot_len];
int ip_packet_len;
char *new_packet;
struct source *sources;
int packing_factor;
int number_of_sources;
int shmem = 0;
int l1_protocol = 0;
int hlt_protocol = 0;
int protocol = 0;
void
generic_q_init (struct generic_q *q)
{
  q->head = q->tail = NULL;
}

void
generic_item_init (struct generic_item *item)
{
  item->next = item->prev = NULL;
  item->q = NULL;
}

void
generic_q_enqueue (struct generic_q *q, struct generic_item *item)
{
  assert (item->prev != item);
  assert (item->next != item);
  if (item->next != NULL || item->prev != NULL)
    assert (item->next != item->prev);
  if (q->tail)
    {
      assert (q->head);
      item->next = q->tail;
      item->prev = NULL;
      q->tail->prev = item;
      q->tail = item;
    }
  else
    {
      assert (q->head == NULL);
      q->head = q->tail = item;
      item->prev = item->next = NULL;
    }
  item->q = q;
  assert (q);
  assert (q->head);
  assert (q->tail);
  assert (q->head->next == NULL);
  assert (q->tail->prev == NULL);
  assert (item->prev != item);
  assert (item->next != item);
  if (item)
    assert (item->q);
}
struct generic_item *
generic_q_dequeue (struct generic_q *q)
{
  struct generic_item *item = NULL;
  assert (q);
  if (q->head)
    {
      assert (q->tail);
      item = q->head;
      q->head = q->head->prev;
      if (q->head)
	q->head->next = NULL;
      else
	q->tail = NULL;
      item->q = NULL;
    }
  else
    {
      assert (!q->tail);
    }
  if (q->head)
    assert (q->head->next == NULL);
  if (q->tail)
    assert (q->tail->prev == NULL);
  return item;
}

void
generic_q_remove (struct generic_q *q, struct generic_item *item)
{
  assert (q);
  assert (q->head);
  assert (q->tail);
  assert (q->head->next == NULL);
  assert (q->tail->prev == NULL);
  assert (item);
  assert (item->prev != item);
  assert (item->next != item);
  if (item->next != NULL || item->prev != NULL)
    assert (item->next != item->prev);
  if (item->prev)
    item->prev->next = item->next;
  else
    q->tail = item->next;
  if (item->next)
    item->next->prev = item->prev;
  else
    q->head = item->prev;
  item->q = NULL;
  assert (q);
  if (q->head)
    assert (q->head->next == NULL);
  if (q->tail)
    assert (q->tail->prev == NULL);
}

void
generic_q_moveto (struct generic_q *q, struct generic_item *item)
{
  assert (item->q != NULL);
  generic_q_remove (item->q, item);
  generic_q_enqueue (q, item);
}

void
packet_cleanup (struct packet_desc *p)
{
}
void
event_cleanup (struct event_desc *e)
{
}
void
cut_dependency (struct event_desc *e, struct packet_desc *p)
{
}
void
add_dependency (struct event_desc *e, struct packet_desc *p)
{
}
void
event_free (struct event_desc *event)
{
}
void
packet_free (struct packet_desc *pkt)
{
}
int
ebuild_get_event (char *buffer, int maxlength)
{
  struct event_set *built;
  int copied;
  built = (struct event_set *) built_events.head;
  while (!built)
    {
      char *new_packet;
      new_packet = malloc (66000);
      assert (new_packet);
      ip_packet_len = recvfrom (socket_l1, new_packet, 66000, 0,
				(struct sockaddr *) &sender_information,
				&sender_sockaddr_len);
      if (ip_packet_len == -1)
	perror ("recvfrom");
      else
	local_stats.mep_received++;
      new_packet = realloc (new_packet, ip_packet_len);
      {
	struct packet_hdr *pkt;
	struct event_set *set;
	int location;
	{
	  mep_packet_len = ip_packet_len - 20;
	  mep = (struct mephdr *) &new_packet[20];
	  if (mep->total_length < mep_packet_len)
	    error (long_packet);
	  if (mep->total_length > mep_packet_len)
	    error (short_packet);
#ifdef NOTDEF
	  {
	    ef = (struct efhdr *) ((char *) mep + 12);
	    if ((ntohs (ip->id) & 0xf0) == 0)
	      error (ip_id);
	    if (ef->event_id & 0xefff)
	      error (ip_id);
	  }
#endif
	  {
	    int n = mep->number_of_events;
	    int data_len = mep->total_length - 12;
	    ef = (struct efhdr *) ((char *) mep + 12);
	    while (n)
	      {
		if (data_len < 4)
		  error (fragment_parsing);
		data_len -= 4 + ef->length;
		ef = (struct efhdr *) ((char *) ef + 4 + ef->length);
		n--;
	      }
	    if (n != 0)
	      error (number_of_fragments);
	    if (mep->number_of_events != packing_factor)
	      error (number_of_fragments);
	  }
	}
	{
	  int xxx;
	  int partition_id =
	    ((struct mephdr *) (&new_packet[20]))->partition_id;
	  //info("partition ID of the packet is 0x%08x\n",partition_id); // LE commented out 17 Aug 2005
	  for (xxx = 0; xxx < number_of_sources; xxx++)
	    if (sources[xxx].id == partition_id)
	      break;
	  assert (xxx < number_of_sources);
	  location = xxx;
	}
	{
	  struct efhdr *frag;
	  int ev_number = ((struct mephdr *) (&new_packet[20]))->l01_id;
	  int frag_length, frag_no;
	  int is_new = 0;
	  int i;
	  {
	    struct event_set *ev_test =
	      (struct event_set *) (incomplete_events.head);
	    while (ev_test != NULL)
	      {
		if (ev_test->number == ev_number)
		  break;
		else
		  ev_test = ev_test->prev;
	      }
	    set = ev_test;
	  }
	  if (set == NULL)
	    {
	      LOCK (&glmutex);
	      set = (struct event_set *) generic_q_dequeue (&null_events);
	      local_stats.events_in_queue++;
	      assert (local_stats.events_in_queue < 250);
	      UNLOCK (&glmutex);
	      assert (set);
	      set->number = ev_number;
	      set->count = 0;
	      set->ev_count = packing_factor;
	      generic_q_enqueue (&incomplete_events,
				 (struct generic_item *) set);
	      nb_incomplete++;
	      is_new = 1;
	    }
	  pkt = PACKET (location, set);
	  if (pkt->received == 0)
	    {
	      pkt->received = 1;
	      pkt->mep = (struct mephdr *) (&new_packet[20]);
	      pkt->frag1 = (struct efhdr *) (&new_packet[32]);
	      pkt->data = new_packet;
	      pkt->len = ip_packet_len;
	      frag = pkt->frag1;
	      frag_length = frag->length;
	      frag_no = ev_number;
	      for (i = 0; i < pkt->mep->number_of_events; i++)
		{
		  {
		    struct event_hdr *ev = EVENT (i, set);
		    struct iovec *vec = FRAGMENT (location, ev);
		    vec->iov_len = frag_length;
		    vec->iov_base = frag->data;
		    ev->len += frag_length;
		    ev->number = frag_no;
		    ev->forwarded = 0;
		  }
		  frag =
		    (struct efhdr *) (((char *) frag) + frag->length + 4);
		  frag_no++;
		  frag_length = frag->length;
		}
	      set->count++;
	      if (set->count == number_of_sources)
		{
		  LOCK (&glmutex);
		  generic_q_moveto (&built_events,
				    (struct generic_item *) set);
		  UNLOCK (&glmutex);
#ifdef MTHREADS
		  pthread_cond_signal (&somethingtoforward);
#endif
		  local_stats.events_built++;
		}
	    }
	  else
	    free (new_packet);
	}
      err:;
      }
      built = (struct event_set *) (built_events.head);
    }
  copied = 0;
  {
    int j, i;
    struct event_hdr *ev;
    for (j = 0; j < packing_factor; j++)
      {
	ev = EVENT (j, built);
	if (ev->forwarded == 0)
	  {
	    for (i = 0; i < number_of_sources; i++)
	      {
		struct iovec *vec = FRAGMENT (i, ev);
		if (copied + vec->iov_len <= maxlength)
		  {
		    memcpy (&buffer[copied], vec->iov_base, vec->iov_len);
		    copied += vec->iov_len;
		  }
		else
		  {
		    copied = -1;
		    break;
		  }
	      }
	    ev->forwarded = 1;
	    if (--(built->ev_count) == 0)
	      {
		local_stats.events_in_queue--;
		{
		  int i;
		  for (i = 0; i < number_of_sources; i++)
		    {
		      if (PACKET (i, built)->received)
			{
			  PACKET (i, built)->received = 0;
			  free (PACKET (i, built)->data);
			}
		    }
		  for (i = 0; i < packing_factor; i++)
		    {
		      EVENT (i, built)->len = 0;
		    }
		  built->count = 0;
		}
		generic_q_moveto (&null_events,
				  (struct generic_item *) built);
	      }
	    break;
	  }
      }
    if (copied == 0)
      abort ();
  }
  return copied;
}

void
ebuild_init ()
{
#ifdef __KERNEL__
  packing_factor = 1;
  number_of_sources = 100;
  sources = kmalloc (number_of_sources * sizeof (struct source), GFP_KERNEL);
  {
    int zzz;
    for (zzz = 0; zzz < number_of_sources; zzz++)
      sources[zzz].id = zzz;
  }
  exports = NULL;
#else
  number_of_sources = 0;
  pass = 1;
  while (pass < 3)
    {
      FILE *cfg;
      char tok[120];
      char line[120];
      int lineno = 0;
      cfg = fopen ("ebuild.cfg", "r");
      assert (cfg != NULL);
      if (pass == 2)
	{
	  sources = malloc (number_of_sources * sizeof (struct source));
	}
      while (fgets (line, 120, cfg) != NULL)
	{
	  int r;
	  lineno++;
	  if (line[0] == '#')
	    continue;
	  if (line[0] == '\n' && line[1] == '\0')
	    continue;
	  if (sscanf (line, "%s", tok) == 0)
	    continue;
	  if (streq (tok, "protocol"))
	    {
	      int number;
	      r = sscanf (line, "%s %i", tok, &number);
	      checkconfigbug (tok, 2);
	      protocol = number;
	    }
	  else if (streq (tok, "board"))
	    {
	      int id, rank;
	      r = sscanf (line, "%s %x %i\n", tok, &id, &rank);
	      checkconfigbug (tok, 3);
	      if (pass == 1)
		{
		  number_of_sources++;
		}
	      else
		sources[rank].id = id;
	    }
	  else if (streq (tok, "shmem"))
	    {
	      int k;
	      r = sscanf (line, "%s %i\n", tok, &k);
	      checkconfigbug (tok, 2);
	      shmem = k;
	    }
	  else if (streq (tok, "packing_factor"))
	    {
	      int p;
	      r = sscanf (line, "%s %i\n", tok, &p);
	      checkconfigbug (tok, 2);
	      packing_factor = p;
	    }
	  else
	    fprintf (stderr, "line %d, unknown keyword \"%s\"\n", lineno,
		     tok);
	}
      fclose (cfg);
      pass++;
    }
  socket_l1 = socket (AF_INET, SOCK_RAW, protocol);
  if (socket_l1 < 0)
    {
      perror ("socket");
      abort ();
    }
  {
    int buff_size = 4194304;
    if (setsockopt (socket_l1, SOL_SOCKET, SO_RCVBUF,
		    (char *) &buff_size, sizeof (buff_size)))
      abort ();
  }
  if (shmem)
    {
      shm_id = shmget (shmem, sizeof (struct ebmon),
		       IPC_CREAT | IPC_EXCL | 0644);
      if (shm_id == -1)
	{
	  perror ("shmget");
	  abort ();
	}
      shared_memory = shmat (shm_id, NULL, SHM_RND);
      if (shared_memory == (char *) -1)
	{
	  perror ("shmat");
	  abort ();
	}
    }
  else
    shared_memory = malloc (sizeof (struct ebmon));
  exports = (struct ebmon *) shared_memory;
#endif
  local_stats.l1_protocol = l1_protocol;
  local_stats.hlt_protocol = hlt_protocol;
  local_stats.packing_factor = packing_factor;
  local_stats.number_of_sources = number_of_sources;
  local_stats.mep_received = 0;
  local_stats.mep_in_queue = 0;
  local_stats.events_built = 0;
  local_stats.events_in_queue = 0;
  local_stats.events_forwarded = 0;
  local_stats.err_events_dropped = 0;
  local_stats.err_ip_id = 0;
  local_stats.err_short_packet = 0;
  local_stats.err_long_packet = 0;
  local_stats.err_total_len = 0;
  local_stats.err_number_of_fragments = 0;
  local_stats.err_identifier = 0;
  local_stats.err_partition_id = 0;
  local_stats.err_fragment_event_id = 0;
  local_stats.err_fragment_event_length = 0;
  local_stats.err_fragment_parsing = 0;
  generic_q_init (&empty_packets);
  generic_q_init (&full_packets);
  generic_q_init (&full_packets2);
  generic_q_init (&null_events);
  generic_q_init (&incomplete_events);
  generic_q_init (&built_events);
  vector_size = sizeof (struct iovec);
  fragment_size = sizeof (struct iovec);
  packet_size = sizeof (struct packet_hdr);
  event_size =
    sizeof (struct event_hdr) + (number_of_sources + 1) * vector_size;
  set_size =
    sizeof (struct event_set) + number_of_sources * packet_size +
    packing_factor * event_size;
  vectors_offset = sizeof (struct event_hdr);
  fragments_offset = vectors_offset + vector_size * 1;
  packets_offset = sizeof (struct event_set);
  events_offset = packets_offset + packet_size * number_of_sources;
  sets_offset = 0;
  event_sets = malloc (500 * set_size);
  assert (event_sets);
  memset (event_sets, 0, 500 * set_size);
  {
    int i;
    for (i = 0; i < 500; i++)
      {
	SET (i, event_sets)->prev = NULL;
	SET (i, event_sets)->next = NULL;
	SET (i, event_sets)->q = NULL;
	SET (i, event_sets)->count = 0;
	generic_q_enqueue (&null_events,
			   (struct generic_item *) SET (i, event_sets));
      }
  }
}
void
ebuild_release ()
{
  close (socket_l1);
  if (shmem)
    {
      shmdt (shared_memory);
      if (shmctl (shm_id, IPC_RMID, &shm_ds) != 0)
	{
	  perror ("shmctl");
	  abort ();
	}

    }
  else
    free (exports);
}
